Index: /trunk/src/sh_tiger0.c
===================================================================
--- /trunk/src/sh_tiger0.c	(revision 584)
+++ /trunk/src/sh_tiger0.c	(revision 1)
@@ -1574,42 +1269,36 @@
 
 static char * sh_tiger_sha1_hash  (char * filename, TigerType what, 
-				   UINT64 * Length, int timeout, 
-				   char * out, size_t len)
-{
-  int cnt;
-  char outbuf[KEY_LEN+1];
+				   unsigned long Length, int timeout)
+{
+  int cnt = (int) Length;  /* fix compiler warning */
+  static char out[KEY_LEN+1];
   unsigned char sha1buffer[20];
 
-  (void) SHA_stream (filename, sha1buffer, Length, timeout, what, SH_VAR_SHA1);
+  if (what != TIGER_FD)
+    {
+      sh_error_handle (ShDFLevel[SH_ERR_T_FILE], FIL__, __LINE__, 0,
+		       MSG_E_SUBGEN, _("Not TIGER_FD"), 
+		       _("sh_tiger_sha1_hash"));
+      return out;
+    }
+
+  (void) sha1_stream (filename, sha1buffer, timeout);
 
   /*@-bufferoverflowhigh -usedef@*/
   for (cnt = 0; cnt < 20; ++cnt)
-    sl_snprintf (&outbuf[cnt*2], 3, _("%02X"),              /* known to fit  */
+    sprintf (&out[cnt*2], _("%02X"),                 /* known to fit  */
 	     (unsigned int) sha1buffer[cnt]);
   /*@+bufferoverflowhigh +usedef@*/
   for (cnt = 40; cnt < KEY_LEN; ++cnt)
-    outbuf[cnt] = '0';
-  outbuf[KEY_LEN] = '\0';
-
-  sl_strlcpy(out, outbuf, len);
+    out[cnt] = '0';
+  out[KEY_LEN] = '\0';
+
   return out;
 }
 
-static char * sh_tiger_sha256_hash  (char * filename, TigerType what, 
-				     UINT64 * Length, int timeout, 
-				     char * out, size_t len)
-{
-  char outbuf[KEYBUF_SIZE];
-
-  (void) SHA_stream (filename, outbuf, Length, timeout, what, SH_VAR_SHA256);
-
-  sl_strlcpy(out, outbuf, len);
-  return out;
-}
-
 /* ifdef USE_SHA1 */
 #endif
 
-static int hash_type = SH_TIGER192;
+static int hash_type = 0;
 
 int sh_tiger_get_hashtype ()
@@ -1618,34 +1307,5 @@
 }
 
-void sh_tiger_get_mask_hashtype(unsigned long * mask)
-{
-  if (hash_type == SH_TIGER192) 
-    *mask |= MODI_TIGER192;
-  else if (hash_type == SH_SHA1)
-    *mask |= MODI_SHA1;
-  else if (hash_type == SH_MD5)
-    *mask |= MODI_MD5;
-  else if (hash_type == SH_SHA256)
-    *mask |= MODI_SHA256;
-  return;
-}
-
-void sh_tiger_set_hashtype_mask(unsigned long mask)
-{
-  unsigned long type = mask & MODI_HASHTYPE;
-
-  if (type == MODI_TIGER192)
-    hash_type = SH_TIGER192;
-  else if (type == MODI_SHA1)
-    hash_type = SH_SHA1;
-  else if (type == MODI_MD5)
-    hash_type = SH_MD5;
-  else if (type == MODI_SHA256)
-    hash_type = SH_SHA256;
-  return;
-}
-
-
-int sh_tiger_hashtype (const char * c)
+int sh_tiger_hashtype (char * c)
 {
   SL_ENTER( _("sh_tiger_hashtype"));
@@ -1657,53 +1317,41 @@
 
   if (0 == strcmp(c, _("TIGER192")))
-    hash_type = SH_TIGER192;
+    hash_type = 0;
+#ifdef USE_MD5
+  else if (0 == strcmp(c, _("SHA1")))    
+    hash_type = 1;
+#endif
 #ifdef USE_SHA1
-  else if (0 == strcmp(c, _("SHA1")))    
-    hash_type = SH_SHA1;
+  else if (0 == strcmp(c, _("MD5")))    
+    hash_type = 2;
+#endif
+  else
+    {
+      SL_RETURN( -1, _("sh_tiger_hashtype"));
+    }
+  SL_RETURN( 0, _("sh_tiger_hashtype"));
+}
+
+static char * sh_tiger_hash_internal (char * filename, TigerType what, 
+				      unsigned long Length, int timeout);
+
+char * sh_tiger_hash (char * filename, TigerType what, 
+		      unsigned long Length)
+{
+  return sh_tiger_hash_internal (filename, what, Length, 0);
+}
+
+char * sh_tiger_generic_hash (char * filename, TigerType what, 
+			      unsigned long Length, int timeout)
+{
+#ifdef USE_SHA1
+  if (hash_type == 1)
+    return sh_tiger_sha1_hash    (filename, what, Length, timeout);
 #endif
 #ifdef USE_MD5
-  else if (0 == strcmp(c, _("MD5")))    
-    hash_type = SH_MD5;
-#endif
-#ifdef USE_SHA1
-  else if (0 == strcmp(c, _("SHA256")))    
-    hash_type = SH_SHA256;
-#endif
-  else
-    {
-      SL_RETURN( -1, _("sh_tiger_hashtype"));
-    }
-  SL_RETURN( 0, _("sh_tiger_hashtype"));
-}
-
-static char * sh_tiger_hash_internal (const char * filename, TigerType what, 
-				      UINT64 * Length, int timeout,
-				      char * out, size_t len);
-
-char * sh_tiger_hash (const char * filename, TigerType what, 
-		      UINT64 Length, char * out, size_t len)
-{
-  UINT64 local_length = Length;
-  char * retval = sh_tiger_hash_internal (filename, what, &local_length, 0, out,len);
-  return retval;
-}
-
-char * sh_tiger_generic_hash (char * filename, TigerType what, 
-			      UINT64 * Length, int timeout,
-			      char * out, size_t len)
-{
-#ifdef USE_SHA1
-  if (hash_type == SH_SHA1)
-    return sh_tiger_sha1_hash    (filename, what, Length, timeout, out, len);
-#endif
-#ifdef USE_MD5
-  if (hash_type == SH_MD5)
-    return sh_tiger_md5_hash     (filename, what, Length, timeout, out, len);
-#endif
-#ifdef USE_SHA1
-  if (hash_type == SH_SHA256)
-    return sh_tiger_sha256_hash  (filename, what, Length, timeout, out, len);
-#endif
-  return sh_tiger_hash_internal  (filename, what, Length, timeout, out, len);
+  if (hash_type == 2)
+    return sh_tiger_md5_hash     (filename, what, Length, timeout);
+#endif
+  return sh_tiger_hash_internal  (filename, what, Length, timeout);
 }
 
@@ -1711,95 +1359,103 @@
  * -------   end new ---------  */
   
-static char * sh_tiger_hash_internal (const char * filename, TigerType what, 
-				      UINT64 * Length, int timeout, 
-				      char * out, size_t len)
-{
-#if defined(TIGER_64_BIT)
-  word64 res[3];
+static char * sh_tiger_hash_internal (char * filename, TigerType what, 
+				      unsigned long Length, int timeout)
+{
+#if defined(HAVE_LONG_64) || defined(HAVE_LONG_LONG_64)
+  /* #ifdef HAVE_LONG_64 */
+  word64 * res;
 #else
-  sh_word32 res[6];
-#endif
-
-  SL_ENTER( _("sh_tiger_hash_internal"));
-
-  SH_VALIDATE_GE(len, (KEY_LEN+1));
-
-  if (NULL != sh_tiger_hash_val (filename, what, Length, timeout, res))
-    {
-#if defined(TIGER_64_BIT)
-      sl_snprintf(out, len,
-		  MYFORMAT,
-		  (sh_word32)(res[0]>>32), 
-		  (sh_word32)(res[0]), 
-		  (sh_word32)(res[1]>>32), 
-		  (sh_word32)(res[1]), 
-		  (sh_word32)(res[2]>>32), 
-		  (sh_word32)(res[2]) );
+  sh_word32 * res;
+#endif
+  static char out[KEY_LEN+1];
+
+  SL_ENTER( _("sh_tiger_hash"));
+
+  res = sh_tiger_hash_val (filename, what, Length, timeout);
+
+  if (res != NULL)
+    {
+      /*@-bufferoverflowhigh -formatconst@*/
+#if defined(HAVE_LONG_64) || defined(HAVE_LONG_LONG_64)
+      /* #ifdef HAVE_LONG_64 */
+      sprintf(out,                                   /* known to fit  */
+	      MYFORMAT,
+	      (sh_word32)(res[0]>>32), 
+	      (sh_word32)(res[0]), 
+	      (sh_word32)(res[1]>>32), 
+	      (sh_word32)(res[1]), 
+	      (sh_word32)(res[2]>>32), 
+	      (sh_word32)(res[2]) );
 #else
-      sl_snprintf(out, len,
-		  MYFORMAT,
-		  (sh_word32)(res[1]), 
-		  (sh_word32)(res[0]), 
-		  (sh_word32)(res[3]), 
-		  (sh_word32)(res[2]), 
-		  (sh_word32)(res[5]), 
-		  (sh_word32)(res[4]) );
-#endif
-      out[len-1] = '\0';
-      SL_RETURN( out, _("sh_tiger_hash_internal"));
-
-    }
-
-   SL_RETURN( SH_KEY_NULL, _("sh_tiger_hash_internal"));
-}
-
-char * sh_tiger_hash_gpg (const char * filename, TigerType what, 
-			  UINT64 Length)
+      sprintf(out,                                   /* known to fit  */
+	      MYFORMAT,
+	      (sh_word32)(res[1]), 
+	      (sh_word32)(res[0]), 
+	      (sh_word32)(res[3]), 
+	      (sh_word32)(res[2]), 
+	      (sh_word32)(res[5]), 
+	      (sh_word32)(res[4]) );
+#endif
+      /*@+bufferoverflowhigh@*/
+      out[KEY_LEN] = '\0';
+      SL_RETURN( out, _("sh_tiger_hash"));
+
+    }
+
+   SL_RETURN( _("000000000000000000000000000000000000000000000000"), 
+	      _("sh_tiger_hash"));
+}
+
+char * sh_tiger_hash_gpg (char * filename, TigerType what, 
+			  unsigned long Length)
 {
   size_t  len;
   char * out;
   char   outhash[48+6+1];
-#if defined(TIGER_64_BIT)
-  word64 res[3];
+#if defined(HAVE_LONG_64) || defined(HAVE_LONG_LONG_64)
+  /* #ifdef HAVE_LONG_64 */
+  word64 * res;
 #else
-  sh_word32 res[6];
-#endif
-  UINT64 local_length = Length;
+  sh_word32 * res;
+#endif
 
   SL_ENTER(_("sh_tiger_hash_gpg"));
 
-  if (NULL != sh_tiger_hash_val (filename, what, &local_length, 0, res))
-    {
-#if defined(TIGER_64_BIT)
-      sl_snprintf(outhash,
-		  sizeof(outhash),
-		  GPGFORMAT,
-		  (sh_word32)(res[0]>>32), 
-		  (sh_word32)(res[0]), 
-		  (sh_word32)(res[1]>>32), 
-		  (sh_word32)(res[1]), 
-		  (sh_word32)(res[2]>>32), 
-		  (sh_word32)(res[2]) );
+  res = sh_tiger_hash_val (filename, what, Length, 0);
+  if (res != NULL)
+    {
+      /*@-bufferoverflowhigh -formatconst@*/
+#if defined(HAVE_LONG_64) || defined(HAVE_LONG_LONG_64)
+      /* #ifdef HAVE_LONG_64 */
+      sprintf(outhash,                               /* known to fit  */
+	      GPGFORMAT,
+	      (sh_word32)(res[0]>>32), 
+	      (sh_word32)(res[0]), 
+	      (sh_word32)(res[1]>>32), 
+	      (sh_word32)(res[1]), 
+	      (sh_word32)(res[2]>>32), 
+	      (sh_word32)(res[2]) );
 #else
-      sl_snprintf(outhash,
-		  sizeof(outhash),
-		  GPGFORMAT,
-		  (sh_word32)(res[1]), 
-		  (sh_word32)(res[0]), 
-		  (sh_word32)(res[3]), 
-		  (sh_word32)(res[2]), 
-		  (sh_word32)(res[5]), 
-		  (sh_word32)(res[4]) );
-#endif
-      outhash[sizeof(outhash)-1] = '\0';
+      sprintf(outhash,                               /* known to fit  */
+	      GPGFORMAT,
+	      (sh_word32)(res[1]), 
+	      (sh_word32)(res[0]), 
+	      (sh_word32)(res[3]), 
+	      (sh_word32)(res[2]), 
+	      (sh_word32)(res[5]), 
+	      (sh_word32)(res[4]) );
+#endif
+      /*@+bufferoverflowhigh@*/
+      outhash[48 + 6] = '\0';
     }
   else
     {
-      sl_strlcpy(outhash,
-		 _("00000000 00000000 00000000  00000000 00000000 00000000"),
-		 sizeof(outhash));
-    }
-
-  if (what == TIGER_FILE && sl_ok_adds(sl_strlen (filename), (2 + 48 + 6)))
+      /*@-bufferoverflowhigh@*/
+      sprintf(outhash,                               /* known to fit  */
+	      _("00000000 00000000 00000000  00000000 00000000 00000000"));
+      /*@+bufferoverflowhigh@*/
+    }
+
+  if (what == TIGER_FILE)
     len = sl_strlen (filename) + 2 + 48 + 6;
   else
@@ -1824,23 +1480,25 @@
 UINT32 * sh_tiger_hash_uint32 (char * filename, 
 			       TigerType what, 
-			       UINT64 Length, UINT32 * out, size_t len)
-{
-#if defined(TIGER_64_BIT)
-  word64 res[3];
+			       unsigned long Length)
+{
+#if defined(HAVE_LONG_64) || defined(HAVE_LONG_LONG_64)
+  /* #ifdef HAVE_LONG_64 */
+  word64 * res;
 #else
-  sh_word32 res[6];
-#endif
-  UINT64 local_length = Length;
+  sh_word32 * res;
+#endif
+
+  static UINT32 out[6];
 
   SL_ENTER(_("sh_tiger_hash_uint32"));
 
-  SH_VALIDATE_GE(len, 6);
-
-  out[0] = 0; out[1] = 0; out[2] = 0;
-  out[3] = 0; out[4] = 0; out[5] = 0;
-
-  if (NULL != sh_tiger_hash_val (filename,  what,  &local_length, 0, res))
-    {
-#if defined(TIGER_64_BIT)
+  memset(out, 0, 6 * sizeof(UINT32));
+
+  res = sh_tiger_hash_val (filename,  what,  Length, 0);
+
+  if (res != NULL)
+    {
+#if defined(HAVE_LONG_64) || defined(HAVE_LONG_LONG_64)
+      /* #ifdef HAVE_LONG_64 */
 	out[0] =  (UINT32)(res[0]>>32); 
 	out[1] =  (UINT32)(res[0]);
Index: /trunk/src/sh_tiger1.c
===================================================================
--- /trunk/src/sh_tiger1.c	(revision 584)
+++ /trunk/src/sh_tiger1.c	(revision 1)
@@ -5,9 +5,6 @@
 #include "config_xor.h"
 
-/* we already inline in the function used for file checksums */
-/* #define UNROLL_COMPRESS */
-#undef UNROLL_COMPRESS
-
-#if !defined(TIGER_64_BIT)
+
+#if !defined(HAVE_LONG_64) && !defined(HAVE_LONG_LONG_64)
 
 /* Tiger: A Fast New Hash Function
@@ -40,5 +37,5 @@
 typedef unsigned short sh_word32;
 #else
-#error No 32 bit type found !
+#error No 32 byte type found !
 #endif
 
@@ -49,4 +46,9 @@
 #define BIG_ENDIAN
 #endif
+
+/* NOTE that this code is NOT FULLY OPTIMIZED for any  */
+/* machine. Assembly code might be much faster on some */
+/* machines, especially if the code is compiled with   */
+/* gcc.                                                */
 
 /* The number of passes of the hash function.          */
@@ -63,5 +65,5 @@
 #define t4 (tiger_table+256*3)
 
-#define sub64(s0, s1, p0, p1) \
+#define sh_sub64(s0, s1, p0, p1) \
       temps0 = (p0); \
       tcarry = s0 < temps0; \
@@ -69,5 +71,5 @@
       s1 -= (p1) + tcarry;
 
-#define add64(s0, s1, p0, p1) \
+#define sh_add64(s0, s1, p0, p1) \
       temps0 = (p0); \
       s0 += temps0; \
@@ -75,26 +77,26 @@
       s1 += (p1) + tcarry;
 
-#define xor64(s0, s1, p0, p1) \
+#define sh_xor64(s0, s1, p0, p1) \
       s0 ^= (p0); \
       s1 ^= (p1);
 
-#define mul5(s0, s1) \
+#define sh_mul5(s0, s1) \
       tempt0 = s0<<2; \
       tempt1 = (s1<<2)|(s0>>30); \
-      add64(s0, s1, tempt0, tempt1);
-
-#define mul7(s0, s1) \
+      sh_add64(s0, s1, tempt0, tempt1);
+
+#define sh_mul7(s0, s1) \
       tempt0 = s0<<3; \
       tempt1 = (s1<<3)|(s0>>29); \
-      sub64(tempt0, tempt1, s0, s1); \
+      sh_sub64(tempt0, tempt1, s0, s1); \
       s0 = tempt0; \
       s1 = tempt1;
 
-#define mul9(s0, s1) \
+#define sh_mul9(s0, s1) \
       tempt0 = s0<<3; \
       tempt1 = (s1<<3)|(s0>>29); \
-      add64(s0, s1, tempt0, tempt1);
-
-#define save_abc \
+      sh_add64(s0, s1, tempt0, tempt1);
+
+#define sh_save_abc \
       aa0 = a0; \
       aa1 = a1; \
@@ -104,6 +106,6 @@
       cc1 = c1;
 
-#define roundX(a0,a1,b0,b1,c0,c1,x0,x1) \
-      xor64(c0, c1, x0, x1); \
+#define sh_round(a0,a1,b0,b1,c0,c1,x0,x1,mul) \
+      sh_xor64(c0, c1, x0, x1); \
       temp0  = t1[((c0)>>(0*8))&0xFF][0] ; \
       temp1  = t1[((c0)>>(0*8))&0xFF][1] ; \
@@ -114,5 +116,5 @@
       temp0 ^= t4[((c1)>>(2*8))&0xFF][0] ; \
       temp1 ^= t4[((c1)>>(2*8))&0xFF][1] ; \
-      sub64(a0, a1, temp0, temp1); \
+      sh_sub64(a0, a1, temp0, temp1); \
       temp0  = t4[((c0)>>(1*8))&0xFF][0] ; \
       temp1  = t4[((c0)>>(1*8))&0xFF][1] ; \
@@ -123,108 +125,79 @@
       temp0 ^= t1[((c1)>>(3*8))&0xFF][0] ; \
       temp1 ^= t1[((c1)>>(3*8))&0xFF][1] ; \
-      add64(b0, b1, temp0, temp1); 
-
-
-#define round5(a0,a1,b0,b1,c0,c1,x0,x1) \
-      roundX(a0,a1,b0,b1,c0,c1,x0,x1); \
-      mul5(b0, b1);
-
-#define round7(a0,a1,b0,b1,c0,c1,x0,x1) \
-      roundX(a0,a1,b0,b1,c0,c1,x0,x1); \
-      mul7(b0, b1);
-
-#define round9(a0,a1,b0,b1,c0,c1,x0,x1) \
-      roundX(a0,a1,b0,b1,c0,c1,x0,x1); \
-      mul9(b0, b1);
-
-
-/* mixed with key_schedule
- */
-#define pass5(a0,a1,b0,b1,c0,c1) \
-      round5(a0,a1,b0,b1,c0,c1,x00,x01); \
-      sub64(x00, x01, x70^0xA5A5A5A5, x71^0xA5A5A5A5); \
-      round5(b0,b1,c0,c1,a0,a1,x10,x11); \
-      xor64(x10, x11, x00, x01); \
-      round5(c0,c1,a0,a1,b0,b1,x20,x21); \
-      add64(x20, x21, x10, x11); \
-      round5(a0,a1,b0,b1,c0,c1,x30,x31); \
-      sub64(x30, x31, x20^((~x10)<<19), ~x21^(((x11)<<19)|((x10)>>13))); \
-      round5(b0,b1,c0,c1,a0,a1,x40,x41); \
-      xor64(x40, x41, x30, x31); \
-      round5(c0,c1,a0,a1,b0,b1,x50,x51); \
-      add64(x50, x51, x40, x41); \
-      round5(a0,a1,b0,b1,c0,c1,x60,x61); \
-      sub64(x60, x61, ~x50^(((x40)>>23)|((x41)<<9)), x51^((~x41)>>23)); \
-      round5(b0,b1,c0,c1,a0,a1,x70,x71);
-
-/* mixed with key_schedule
- */
-#define pass7(a0,a1,b0,b1,c0,c1) \
-      round7(a0,a1,b0,b1,c0,c1,x00,x01); \
-      sub64(x00, x01, x70^0xA5A5A5A5, x71^0xA5A5A5A5); \
-      round7(b0,b1,c0,c1,a0,a1,x10,x11); \
-      xor64(x10, x11, x00, x01); \
-      round7(c0,c1,a0,a1,b0,b1,x20,x21); \
-      add64(x20, x21, x10, x11); \
-      round7(a0,a1,b0,b1,c0,c1,x30,x31); \
-      sub64(x30, x31, x20^((~x10)<<19), ~x21^(((x11)<<19)|((x10)>>13))); \
-      round7(b0,b1,c0,c1,a0,a1,x40,x41); \
-      xor64(x40, x41, x30, x31); \
-      round7(c0,c1,a0,a1,b0,b1,x50,x51); \
-      add64(x50, x51, x40, x41); \
-      round7(a0,a1,b0,b1,c0,c1,x60,x61); \
-      sub64(x60, x61, ~x50^(((x40)>>23)|((x41)<<9)), x51^((~x41)>>23)); \
-      round7(b0,b1,c0,c1,a0,a1,x70,x71);
-
-/* mixed with key_schedule
- */
-#define pass9(a0,a1,b0,b1,c0,c1) \
-      round9(a0,a1,b0,b1,c0,c1,x00,x01); \
-      sub64(x00, x01, x70^0xA5A5A5A5, x71^0xA5A5A5A5); \
-      round9(b0,b1,c0,c1,a0,a1,x10,x11); \
-      xor64(x10, x11, x00, x01); \
-      round9(c0,c1,a0,a1,b0,b1,x20,x21); \
-      add64(x20, x21, x10, x11); \
-      round9(a0,a1,b0,b1,c0,c1,x30,x31); \
-      sub64(x30, x31, x20^((~x10)<<19), ~x21^(((x11)<<19)|((x10)>>13))); \
-      round9(b0,b1,c0,c1,a0,a1,x40,x41); \
-      xor64(x40, x41, x30, x31); \
-      round9(c0,c1,a0,a1,b0,b1,x50,x51); \
-      add64(x50, x51, x40, x41); \
-      round9(a0,a1,b0,b1,c0,c1,x60,x61); \
-      sub64(x60, x61, ~x50^(((x40)>>23)|((x41)<<9)), x51^((~x41)>>23)); \
-      round9(b0,b1,c0,c1,a0,a1,x70,x71);
-
-#define key_schedule \
-      xor64(x70, x71, x60, x61); \
-      add64(x00, x01, x70, x71); \
-      sub64(x10, x11, x00^((~x70)<<19), ~x01^(((x71)<<19)|((x70)>>13))); \
-      xor64(x20, x21, x10, x11); \
-      add64(x30, x31, x20, x21); \
-      sub64(x40, x41, ~x30^(((x20)>>23)|((x21)<<9)), x31^((~x21)>>23)); \
-      xor64(x50, x51, x40, x41); \
-      add64(x60, x61, x50, x51); \
-      sub64(x70, x71, x60^0x89ABCDEF, x61^0x01234567);
-
-#define feedforward \
-      xor64(a0, a1, aa0, aa1); \
-      sub64(b0, b1, bb0, bb1); \
-      add64(c0, c1, cc0, cc1);
-
-#define compress \
-      pass5(a0,a1,b0,b1,c0,c1); \
-      key_schedule; \
-      pass7(c0,c1,a0,a1,b0,b1); \
-      key_schedule; \
-      pass9(b0,b1,c0,c1,a0,a1); \
-      feedforward
+      sh_add64(b0, b1, temp0, temp1); \
+      if((mul)==5) \
+	{sh_mul5(b0, b1);} \
+      else \
+	if((mul)==7) \
+	  {sh_mul7(b0, b1);} \
+	else \
+	  {sh_mul9(b0, b1)};
+
+#define sh_pass(a0,a1,b0,b1,c0,c1,mul) \
+      sh_round(a0,a1,b0,b1,c0,c1,x00,x01,mul); \
+      sh_round(b0,b1,c0,c1,a0,a1,x10,x11,mul); \
+      sh_round(c0,c1,a0,a1,b0,b1,x20,x21,mul); \
+      sh_round(a0,a1,b0,b1,c0,c1,x30,x31,mul); \
+      sh_round(b0,b1,c0,c1,a0,a1,x40,x41,mul); \
+      sh_round(c0,c1,a0,a1,b0,b1,x50,x51,mul); \
+      sh_round(a0,a1,b0,b1,c0,c1,x60,x61,mul); \
+      sh_round(b0,b1,c0,c1,a0,a1,x70,x71,mul);
+
+#define sh_key_schedule \
+      sh_sub64(x00, x01, x70^0xA5A5A5A5, x71^0xA5A5A5A5); \
+      sh_xor64(x10, x11, x00, x01); \
+      sh_add64(x20, x21, x10, x11); \
+      sh_sub64(x30, x31, x20^((~x10)<<19), ~x21^(((x11)<<19)|((x10)>>13))); \
+      sh_xor64(x40, x41, x30, x31); \
+      sh_add64(x50, x51, x40, x41); \
+      sh_sub64(x60, x61, ~x50^(((x40)>>23)|((x41)<<9)), x51^((~x41)>>23)); \
+      sh_xor64(x70, x71, x60, x61); \
+      sh_add64(x00, x01, x70, x71); \
+      sh_sub64(x10, x11, x00^((~x70)<<19), ~x01^(((x71)<<19)|((x70)>>13))); \
+      sh_xor64(x20, x21, x10, x11); \
+      sh_add64(x30, x31, x20, x21); \
+      sh_sub64(x40, x41, ~x30^(((x20)>>23)|((x21)<<9)), x31^((~x21)>>23)); \
+      sh_xor64(x50, x51, x40, x41); \
+      sh_add64(x60, x61, x50, x51); \
+      sh_sub64(x70, x71, x60^0x89ABCDEF, x61^0x01234567);
+
+#define sh_feedforward \
+      sh_xor64(a0, a1, aa0, aa1); \
+      sh_sub64(b0, b1, bb0, bb1); \
+      sh_add64(c0, c1, cc0, cc1);
+
+#ifdef UNROLL_COMPRESS
+#define sh_compress \
+      sh_save_abc \
+      sh_pass(a0,a1,b0,b1,c0,c1,5); \
+      sh_key_schedule; \
+      sh_pass(c0,c1,a0,a1,b0,b1,7); \
+      sh_key_schedule; \
+      sh_pass(b0,b1,c0,c1,a0,a1,9); \
+      for(pass_no=3; pass_no<PASSES; pass_no++) { \
+        sh_key_schedule \
+	sh_pass(a0,a1,b0,b1,c0,c1,9); \
+	tmpa=a0; a0=c0; c0=b0; b0=tmpa; \
+	tmpa=a1; a1=c1; c1=b1; b1=tmpa;} \
+      sh_feedforward
+#else
+#define sh_compress \
+      sh_save_abc \
+      for(pass_no=0; pass_no<PASSES; pass_no++) { \
+        if(pass_no != 0) {sh_key_schedule} \
+	sh_pass(a0,a1,b0,b1,c0,c1,(pass_no==0?5:pass_no==1?7:9)) \
+	tmpa=a0; a0=c0; c0=b0; b0=tmpa; \
+	tmpa=a1; a1=c1; c1=b1; b1=tmpa;} \
+      sh_feedforward
+#endif
 
 #define tiger_compress_macro(str, state) \
 { \
-  register sh_word32 a0, a1, b0, b1, c0, c1; \
+  register sh_word32 a0, a1, b0, b1, c0, c1, tmpa; \
   sh_word32 aa0, aa1, bb0, bb1, cc0, cc1; \
   sh_word32 x00, x01, x10, x11, x20, x21, x30, x31, \
-                  x40, x41, x50, x51, x60, x61, x70, x71; \
-  sh_word32 temp0, temp1, tempt0, tempt1, temps0, tcarry; \
+         x40, x41, x50, x51, x60, x61, x70, x71; \
+  register sh_word32 temp0, temp1, tempt0, tempt1, temps0, tcarry; \
+  int pass_no; \
 \
   a0 = state[0]; \
@@ -235,6 +208,4 @@
   c1 = state[5]; \
 \
-      save_abc \
-\
   x00=str[0*2]; x01=str[0*2+1]; x10=str[1*2]; x11=str[1*2+1]; \
   x20=str[2*2]; x21=str[2*2+1]; x30=str[3*2]; x31=str[3*2+1]; \
@@ -242,5 +213,5 @@
   x60=str[6*2]; x61=str[6*2+1]; x70=str[7*2]; x71=str[7*2+1]; \
 \
-  compress; \
+  sh_compress; \
 \
   state[0] = a0; \
@@ -252,11 +223,10 @@
 }
 
-#if defined(UNROLL_COMPRESS)
+#ifdef UNROLL_COMPRESS
 /* The compress function is inlined */
 #define tiger_compress(str, state) \
   tiger_compress_macro(((sh_word32*)str), ((sh_word32*)state))
-
-#else
-
+#else
+/* The compress function is a function */
 void
 tiger_compress(sh_word32 *str, sh_word32 state[6])
@@ -267,5 +237,5 @@
 
 void
-tiger_t(const sh_word32 *str, sh_word32 length, sh_word32 res[6])
+tiger_t(sh_word32 *str, sh_word32 length, sh_word32 res[6])
 {
   register sh_word32 i;
@@ -279,8 +249,8 @@
 #ifdef BIG_ENDIAN
       for(j=0; j<64; j++)
-        temp[j^3] = ((sh_byte*)str)[j];
-      tiger_compress_macro(((sh_word32*)temp), res);
-#else
-      tiger_compress_macro(str, res);
+	temp[j^3] = ((sh_byte*)str)[j];
+      tiger_compress(((sh_word32*)temp), res);
+#else
+      tiger_compress(str, res);
 #endif
       str += 16;
@@ -288,18 +258,9 @@
 }
 
-
-void tiger(sh_word32 *str, sh_word32 length, sh_word32 res[6])
+void
+tiger(sh_word32 *str, sh_word32 length, sh_word32 res[6])
 {
   register sh_word32 i, j;
   sh_byte temp[64];
-
-  /*
-   * res[0]=0x89ABCDEF;
-   * res[1]=0x01234567;
-   * res[2]=0x76543210;
-   * res[3]=0xFEDCBA98;
-   * res[4]=0xC3B2E187;
-   * res[5]=0xF096A5B4;
-   */
 
   for(i=length; i>=64; i-=64)
@@ -346,4 +307,18 @@
 }
 
-#endif
-
+#else
+void dummy_1 (int a)
+{
+  (void) a;
+  return;
+}
+#endif
+
+
+
+
+
+
+
+
+
